/* The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is the Bugzilla Bug Tracking System.
 * 
 * The Initial Developer of the Original Code is Netscape Communications
 * Corporation. Portions created by Netscape are
 * Copyright (C) 1998 Netscape Communications Corporation. All
 * Rights Reserved.
 * 
 * Contributor(s): Christian Reis <kiko@async.com.br>
 *                 David Lawrence <dkl@redhat.com>
 */

// Functions to update form select elements for the show_bug.cgi page.

var selectUpdated = [];
var savedSelects = [];
savedSelects['product'] = [];
savedSelects['component'] = [];
savedSelects['version'] = [];
savedSelects['target_milestone'] = [];

/**
 * Update the select field with results from the xmlrpc requests
 *
 * @param  field Name of select field to update
 * @return None
 */
function updateSelectField (field) {
    if (selectUpdated[field] == 1) return true;
    var sel = document.getElementById(field);
    var prod_selected = document.getElementById('product').value;
    savedSelects[field] = savedSelects[field].length == 0 ? get_selection(sel, false, true, null) : savedSelects[field];
    sel.disabled = true;
    var callback = {
        params: [ { names:[prod_selected] } ],
        onSuccess:function(result) {
            var index = 0;
            if (field == 'component') index = 0;
            if (field == 'version') index = 1;
            if (field == 'target_milestone') index = 2;
            var list = result[prod_selected][index]
            bz_populateSelectFromArray(sel, list, false, true);
            selectUpdated[field] = 1;
            restoreSelection(sel, savedSelects[field]);
            sel.disabled = false;
        }
    }
    var client = new rpc.ServiceProxy(server_url,
        {   methods:['Product.get'],
            protocol:'XML-RPC' });
    client.Product.get(callback);
}


